/*
 * @Author: ZengJing
 * @Date: 2024-02-04 09:39:21
 * @LastEditTime: 2024-02-04 17:27:27
 * @LastEditors: ZengJing
 * @Description:
 * @FilePath: \xform\src\core\Account\components\ExportTemplate\Receipt.js
 */
import React, { useState, useImperativeHandle, forwardRef, useMemo, useRef } from 'react';
import styles from './receipt.less';
import moment from 'moment';
const Receipt = props => {
  moment.locale('zh-cn');

  const { dataList, title } = props;

  const arr = ['坐标', '地址', '图片'];
  const dataSource =
    dataList?.length > 0
      ? dataList.map((x, index) => {
          return {
            id: x.id,
            webRow: x.webRow.filter((v, i) => {
              if (!arr.some(n => v.shape.includes(n))) {
                return v;
              }
            }),
          };
        })
      : null;
  const columnCount = dataSource?.length > 0 ? dataSource[0].webRow.length + 1 : 0;

  const footRows = ['记账', '保管', '验收', '提货人', '制单'];

  const splitOddNumber = oddNumber => {
    if (oddNumber % 2 !== 1) {
      [oddNumber / 2, oddNumber / 2];
    }

    const firstNumber = Math.floor(oddNumber / 2);
    const secondNumber = firstNumber + 1;

    return [firstNumber, secondNumber];
  };
  return (
    <>
      <div className={styles.content}>
        <table>
          <tr>
            <th colSpan={columnCount} className={styles.headerTxt}>
              <span>{title}</span>
            </th>
          </tr>
          <tr>
            <th colSpan={splitOddNumber(columnCount)[0]} className={styles.headerLeft}>
              单位：
            </th>
            <th colSpan={splitOddNumber(columnCount)[1]} className={styles.headerRight}>
              日期：{moment().format('LL')}
            </th>
          </tr>
          <tr>
            <th>序号</th>
            {dataSource?.length > 0 ? dataSource[0].webRow.map((x, index) => <th>{x.fieldName}</th>) : null}
          </tr>

          {dataSource?.length > 0
            ? dataSource.map((x, index) => (
                <tr>
                  <td>{index + 1}</td>
                  {x.webRow.map((v, i) => (
                    <td>{v.fieldValue}</td>
                  ))}
                </tr>
              ))
            : null}
          <tr>
            <td>合计</td>
            {dataSource?.length > 0 ? dataSource[0].webRow.map((x, index) => <td></td>) : null}
          </tr>
          <tr>
            {dataSource?.length > 0
              ? dataSource[0].webRow.map((x, i) => {
                  if (footRows.length >= i + 1) {
                    return <td>{footRows[i]}</td>;
                  } else {
                    return <td></td>;
                  }
                })
              : null}
            <td></td>
          </tr>
        </table>
      </div>
    </>
  );
};

export default Receipt;
